package com.sa.ibiz.demo.demo.domain;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonProperty.Access;
import lombok.Data;
import org.springframework.beans.BeanUtils;
import org.springframework.cglib.beans.BeanMap;
import org.springframework.cglib.beans.BeanGenerator;
import com.baomidou.mybatisplus.annotation.TableLogic;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.FieldFill;
import java.util.Map;
import java.util.HashMap;
import org.springframework.util.StringUtils;
import com.sa.ibiz.demo.ibizutil.security.AuthenticationUser;
import java.util.Date;
import javax.validation.constraints.NotBlank;
import javax.validation.constraints.Size;
import org.springframework.util.DigestUtils;
import org.springframework.util.StringUtils;
import java.util.UUID;
import javax.validation.constraints.NotNull;
import java.io.Serializable;
import org.springframework.cglib.beans.BeanCopier;
import com.sa.ibiz.demo.ibizutil.annotation.Dict;
import com.sa.ibiz.demo.ibizutil.domain.EntityBase;
import java.io.Serializable;
import com.baomidou.mybatisplus.core.toolkit.IdWorker;
import java.math.BigInteger;
import com.sa.ibiz.demo.ibizutil.enums.FillMode;
import com.sa.ibiz.demo.ibizutil.enums.PredefinedType;
import com.sa.ibiz.demo.ibizutil.annotation.PreField;
import com.alibaba.fastjson.annotation.JSONField;


/**
 * 实体[WFUIWizard] 数据对象
 */
@TableName(value = "t_WFUIWIZARD",resultMap = "WFUIWizardResultMap")
@JsonIgnoreProperties(ignoreUnknown = true)
@Data
public class WFUIWizard extends EntityBase implements Serializable{

    private String actionmode;
    private String actionparam;
    @PreField(fill= FillMode.INSERT,preType = PredefinedType.CREATEDATE)
    private Timestamp createdate;
    @PreField(fill= FillMode.INSERT,preType = PredefinedType.CREATEMAN)
    @Dict(dictName = "ionicdemo_SysOperatorCodeList")
    private String createman;
    private String datainfo;
    @PreField(fill= FillMode.INSERT_UPDATE,preType = PredefinedType.UPDATEDATE)
    private Timestamp updatedate;
    @PreField(fill= FillMode.INSERT_UPDATE,preType = PredefinedType.UPDATEMAN)
    @Dict(dictName = "ionicdemo_SysOperatorCodeList")
    private String updateman;
    @Dict(dictName = "ionicdemo_WFGotoStepCodeList")
    private String wfstepvalue;
    @TableId(value= "wfuiwizardid",type=IdType.UUID)//指定主键生成策略
    private String wfuiwizardid;
    private String wfuiwizardname;
    /**
     *  设置属性值[操作模式]
     *  @param actionmode
     */
    public void setActionmode(String actionmode){
        if(StringUtils.isEmpty(actionmode))
            actionmode=null;
        this.actionmode = actionmode;
        this.set("actionmodedirtyflag",true);
    }
    /**
     *  获取属性值[操作模式]
     */
    public String getActionmode(){
        return this.actionmode;
    }
    /**
     *  重置属性值[操作模式]
     */
    public void resetActionmode(){
        this.set("actionmodedirtyflag",false);
        this.actionmode = null;
    }
    /**
     *  设置属性值[操作参数]
     *  @param actionparam
     */
    public void setActionparam(String actionparam){
        if(StringUtils.isEmpty(actionparam))
            actionparam=null;
        this.actionparam = actionparam;
        this.set("actionparamdirtyflag",true);
    }
    /**
     *  获取属性值[操作参数]
     */
    public String getActionparam(){
        return this.actionparam;
    }
    /**
     *  重置属性值[操作参数]
     */
    public void resetActionparam(){
        this.set("actionparamdirtyflag",false);
        this.actionparam = null;
    }
    /**
     *  设置属性值[建立时间]
     *  @param createdate
     */
    public void setCreatedate(Timestamp createdate){
        this.createdate = createdate;
        this.set("createdatedirtyflag",true);
    }
    /**
     *  获取属性值[建立时间]
     */
    public Timestamp getCreatedate(){
        return this.createdate;
    }
    /**
     *  重置属性值[建立时间]
     */
    public void resetCreatedate(){
        this.set("createdatedirtyflag",false);
        this.createdate = null;
    }
    /**
     *  设置属性值[建立人]
     *  @param createman
     */
    public void setCreateman(String createman){
        if(StringUtils.isEmpty(createman))
            createman=null;
        this.createman = createman;
        this.set("createmandirtyflag",true);
    }
    /**
     *  获取属性值[建立人]
     */
    public String getCreateman(){
        return this.createman;
    }
    /**
     *  重置属性值[建立人]
     */
    public void resetCreateman(){
        this.set("createmandirtyflag",false);
        this.createman = null;
    }
    /**
     *  设置属性值[操作数据信息]
     *  @param datainfo
     */
    public void setDatainfo(String datainfo){
        if(StringUtils.isEmpty(datainfo))
            datainfo=null;
        this.datainfo = datainfo;
        this.set("datainfodirtyflag",true);
    }
    /**
     *  获取属性值[操作数据信息]
     */
    public String getDatainfo(){
        return this.datainfo;
    }
    /**
     *  重置属性值[操作数据信息]
     */
    public void resetDatainfo(){
        this.set("datainfodirtyflag",false);
        this.datainfo = null;
    }
    /**
     *  设置属性值[更新时间]
     *  @param updatedate
     */
    public void setUpdatedate(Timestamp updatedate){
        this.updatedate = updatedate;
        this.set("updatedatedirtyflag",true);
    }
    /**
     *  获取属性值[更新时间]
     */
    public Timestamp getUpdatedate(){
        return this.updatedate;
    }
    /**
     *  重置属性值[更新时间]
     */
    public void resetUpdatedate(){
        this.set("updatedatedirtyflag",false);
        this.updatedate = null;
    }
    /**
     *  设置属性值[更新人]
     *  @param updateman
     */
    public void setUpdateman(String updateman){
        if(StringUtils.isEmpty(updateman))
            updateman=null;
        this.updateman = updateman;
        this.set("updatemandirtyflag",true);
    }
    /**
     *  获取属性值[更新人]
     */
    public String getUpdateman(){
        return this.updateman;
    }
    /**
     *  重置属性值[更新人]
     */
    public void resetUpdateman(){
        this.set("updatemandirtyflag",false);
        this.updateman = null;
    }
    /**
     *  设置属性值[调整步骤值]
     *  @param wfstepvalue
     */
    public void setWfstepvalue(String wfstepvalue){
        if(StringUtils.isEmpty(wfstepvalue))
            wfstepvalue=null;
        this.wfstepvalue = wfstepvalue;
        this.set("wfstepvaluedirtyflag",true);
    }
    /**
     *  获取属性值[调整步骤值]
     */
    public String getWfstepvalue(){
        return this.wfstepvalue;
    }
    /**
     *  重置属性值[调整步骤值]
     */
    public void resetWfstepvalue(){
        this.set("wfstepvaluedirtyflag",false);
        this.wfstepvalue = null;
    }
    /**
     *  设置属性值[工作流操作界面标识]
     *  @param wfuiwizardid
     */
    public void setWfuiwizardid(String wfuiwizardid){
        if(StringUtils.isEmpty(wfuiwizardid))
            wfuiwizardid=null;
        this.wfuiwizardid = wfuiwizardid;
        this.set("wfuiwizardiddirtyflag",true);
    }
    /**
     *  获取属性值[工作流操作界面标识]
     */
    public String getWfuiwizardid(){
        return this.wfuiwizardid;
    }
    /**
     *  重置属性值[工作流操作界面标识]
     */
    public void resetWfuiwizardid(){
        this.set("wfuiwizardiddirtyflag",false);
        this.wfuiwizardid = null;
    }
    /**
     *  设置属性值[工作流操作界面名称]
     *  @param wfuiwizardname
     */
    public void setWfuiwizardname(String wfuiwizardname){
        if(StringUtils.isEmpty(wfuiwizardname))
            wfuiwizardname=null;
        this.wfuiwizardname = wfuiwizardname;
        this.set("wfuiwizardnamedirtyflag",true);
    }
    /**
     *  获取属性值[工作流操作界面名称]
     */
    public String getWfuiwizardname(){
        return this.wfuiwizardname;
    }
    /**
     *  重置属性值[工作流操作界面名称]
     */
    public void resetWfuiwizardname(){
        this.set("wfuiwizardnamedirtyflag",false);
        this.wfuiwizardname = null;
    }
    /**
     * 重置当前数据对象属性值
     */
    public  void reset(){
        resetActionmode();
        resetActionparam();
        resetCreatedate();
        resetCreateman();
        resetDatainfo();
        resetUpdatedate();
        resetUpdateman();
        resetWfstepvalue();
        resetWfuiwizardid();
        resetWfuiwizardname();
    }
     /**
     * 获取数据主键（普通主键与联合主键）
     * @return
     */
    @JsonIgnore
    public Serializable getDefaultPrimaryKey()
    {
	    //随机生成主键
         return  IdWorker.get32UUID();

    }
     /**
     * 复制当前对象数据到目标对象(粘贴重置)
     *
     * @throws Exception
     */
    public WFUIWizard copyTo(WFUIWizard targetEntity)
	{
		BeanCopier copier=BeanCopier.create(WFUIWizard.class, WFUIWizard.class, false);
		copier.copy(this, targetEntity, null);
        targetEntity.resetWfuiwizardid();
		return targetEntity;
	}
}